/*
 * $Id: gp.h,v 1.3 2001/08/23 12:45:37 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */

/**
 * Galactica Proxy header file.
 *
 * @version $Revision: 1.3 $
 */
#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif
#if defined(__APPLE__) && defined(__MACH__)
#include <OpenGL/gl.h>	// Header File For The OpenGL32 Library
#include <OpenGL/glu.h>	// Header File For The GLu32 Library
#else
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#endif
#include "SDL.h"

#include "hashtable.h"

#define HOST_NAME_LENGTH 32

typedef struct {
  char name[HOST_NAME_LENGTH];
  Hashtable pages;
  GLfloat x, y, z;
  GLfloat mx, my, mz;
  GLuint texture;
  GLfloat txWidth, txHeight;
  int start;
  int isActive;
} Host;

#define PATH_NAME_LENGTH 64
#define TITLE_LENGTH 64

typedef struct {
  char path[PATH_NAME_LENGTH];
  char title[TITLE_LENGTH];
  Hashtable bLinks;
  Host *host;
  GLfloat x, y, z;
  GLfloat mx, my, mz;
  int r, g, b;
  GLuint texture;
  GLfloat txWidth, txHeight;
  int drawnTitle;
  int start;
  int isActive;
} Page;

typedef struct {
  int hostIdx;
  int pageIdx;
} Link;

#define FRAG_NAME_LENGTH 16

typedef struct {
  char name[FRAG_NAME_LENGTH];
  GLfloat x, y, z;
  GLfloat mx, my, mz;
  int r, g, b;
  GLuint texture;
  GLfloat txWidth, txHeight;
  int cnt;
  int start;
} Frag;

void hookProxyConn(char*, char*, char*, char*, int, char*, int, SDL_mutex*);
int sdlThread(void*);
